#include "libcpp.h"
#include "liberr.h"
#include "sim.h"
#include "transf.h"
using namespace libcpp;
using namespace std;


int main()
  {
// THE SEED

  INT_32BIT seed_vol = 333;
  INT_32BIT seed_lev = 333;
//THE PARAMETERS

  REAL theta_1 = 0.4068; REAL kappa_1 = 0.0128; REAL sigma_1 = 0.0954; //slow mean-reversion
  REAL theta_2 = 0.4068; REAL kappa_2 = 0.6931; REAL sigma_2 = 0.7023; //fast mean-reversion

  REAL c_0 = 0.0025; REAL b_0 = 4.0; REAL c_1 = 1.2080*pow(10.0,-6.0); REAL b_1 = 12.0; REAL thre = 0.40; //thre is the variable to determine from where we start the distribution
  REAL k_0 = 0.5; REAL k_1 = 0.5/(theta_1+theta_2); //the devision by theta guarantees the two parts have the same mean
  REAL trunc = 0.5046; //should be a function of the paramters, should match later the estimation code and change for the different setups

  realmat par_lev(5,1,0.0); par_lev[1] = c_0; par_lev[2] = b_0; par_lev[3] = c_1; par_lev[4] = b_1; par_lev[5] = thre;
  realmat par_vol(6,1,0.0); par_vol[1] = theta_1; par_vol[2] = kappa_1; par_vol[3] = sigma_1;
  par_vol[4] = theta_2; par_vol[5] = kappa_2; par_vol[6] = sigma_2;
//CONTROL VARIABLES

  INTEGER T = 5000; 
  INTEGER freq = 400; //#of hf obs. per day
  INTEGER neul = 5; //# of euler subintervals in each hf obs.
  INTEGER nfiles = 1000;
 
  for (INTEGER i=1; i<=nfiles; i++) {
     string filename_a; string filename_b;
     char number[5]; sprintf(number,"%d",i);
     string temp_a = "iv_";
     string temp_b = "jm_";
     string temp1 =  "4_00_"; 
     string temp2 = ".dat"; string temp3 = number;
     filename_a = temp_a+temp1+temp3+temp2;
     filename_b = temp_b+temp1+temp3+temp2;

     realmat rets = ret(par_vol, par_lev, k_0, k_1, seed_vol, seed_lev, T, freq, neul);
//     vecwrite("temp.dat",rets);
     realmat tv = out_tv(rets, T, freq, trunc);
     realmat jm = out_jumps(rets, T, freq, trunc);
     cout<<i<<'\n';
     vecwrite(filename_a.c_str(),tv);
     vecwrite(filename_b.c_str(),jm);
  }  
  return 0;
  }

