#include <sstream>
#include <cerrno>
#include "libcpp.h"

using namespace libcpp;
using namespace std;

REAL bv(vector<REAL>& ret) {

  REAL output = 0.0; INTEGER T = ret.size();
  REAL rv = pow(ret[0],2.0);
  for (INTEGER t=1; t<=T-1; t++) {
    output += abs(ret[t-1]*ret[t]);
    rv += pow(ret[t],2.0);
  }
  output *= 3.14/2.0;
  if (output>rv) {output = rv;} //i.e. we take min(rv,bv) as an output

  return output;
}

REAL tv(vector<REAL>& ret, REAL& trunc) {

  REAL output = 0.0; INTEGER T = ret.size();
  for (INTEGER t=0; t<=T-1; t++) {
    if (abs(ret[t])<=trunc) {
       output += pow(ret[t],2.0);
    }
  }
  return output;
}

vector<REAL> bj(vector<REAL>& ret, REAL& trunc) {

  INTEGER T = ret.size(); vector<REAL> output;
  for (INTEGER t=0; t<=T-1; t++) {
    if (ret[t]>=trunc) {
       output.push_back(ret[t]);
    }
  }
  return output;
}

realmat out_tv(realmat& ret, INTEGER& T, INTEGER& freq, REAL& trunc) {
  REAL alpha = 4.0*pow(freq,-0.49); REAL thre = trunc; //this is the truncation to be used which can change from day to day
  realmat output(T,2,0.0);
  for (INTEGER t=1; t<=T; t++) {
    vector<REAL> ret_t(freq,0.0);
    for (INTEGER i=1; i<=freq; i++) {
      ret_t[i-1] = ret[(t-1)*freq+i];
    }
    REAL trunc_vol = alpha*pow(bv(ret_t),0.5); thre=trunc;
    if (trunc < trunc_vol) {thre = trunc_vol;}
    vector<REAL> temp = bj(ret_t,thre); INTEGER N = temp.size();
    output(t,1) = tv(ret_t,trunc_vol); output(t,2) = N;
  }

  return output;
}

realmat out_jumps(realmat& ret, INTEGER& T, INTEGER& freq, REAL& trunc) {
  REAL alpha = 4.0*pow(freq,-0.49); REAL thre = trunc; //this is the truncation to be used which can change from day to day
  vector<REAL> output;

  for (INTEGER t=1; t<=T; t++) {
    vector<REAL> ret_t(freq,0.0);
    for (INTEGER i=1; i<=freq; i++) {
      ret_t[i-1] = ret[(t-1)*freq+i];
    }
    if (trunc <alpha*pow(bv(ret_t),0.5)) {
       thre = alpha*pow(bv(ret_t),0.5);
    }
    else {
      thre = trunc;
    }
    for (INTEGER i=1; i<=freq; i++) {
      if (ret[(t-1)*freq+i]>=thre) {
          output.push_back(ret[(t-1)*freq+i]);
      }
    }
  }
  INTEGER N = output.size(); realmat out_mat(N,1,0.0);
  for (INTEGER i=1; i<=N; i++) {
     out_mat[i] = output[i-1];
  }
  return out_mat;
}

